Index: ui/ui.progressbar.js
===================================================================
--- ui/ui.progressbar.js	(revision 946)
+++ ui/ui.progressbar.js	(working copy)
@@ -79,7 +79,7 @@
 						self._animate();
 					}
 					else {
-						delete jQuery.easing[self.identifier];
+						delete $.easing[self.identifier];
 					}
 				}
 			}
@@ -99,7 +99,7 @@
 			.removeData("progressbar").unbind(".progressbar")
 			.find('.ui-progressbar-wrap').remove();
 		
-		delete jQuery.easing[this.identifier];
+		delete $.easing[this.identifier];
 	},
 
 	disable: function() {
@@ -145,7 +145,7 @@
 			return;
 		}
 		
-		jQuery.easing[this.identifier] = function (x, t, b, c, d) {
+		$.easing[this.identifier] = function (x, t, b, c, d) {
 			var inc = options.increment,
 				width = options.width,
 				step = ((inc > width ? width : inc)/width),
Index: ui/effects.core.js
===================================================================
--- ui/effects.core.js	(revision 946)
+++ ui/effects.core.js	(working copy)
@@ -183,8 +183,8 @@
  */
 
 // We override the animation for all of these color styles
-jQuery.each(['backgroundColor', 'borderBottomColor', 'borderLeftColor', 'borderRightColor', 'borderTopColor', 'color', 'outlineColor'], function(i,attr){
-		jQuery.fx.step[attr] = function(fx){
+$.each(['backgroundColor', 'borderBottomColor', 'borderLeftColor', 'borderRightColor', 'borderTopColor', 'color', 'outlineColor'], function(i,attr){
+		$.fx.step[attr] = function(fx){
 				if ( fx.state == 0 ) {
 						fx.start = getColor( fx.elem, attr );
 						fx.end = getRGB( fx.end );
@@ -231,17 +231,17 @@
 				return colors['transparent'];
 
 		// Otherwise, we're most likely dealing with a named color
-		return colors[jQuery.trim(color).toLowerCase()];
+		return colors[$.trim(color).toLowerCase()];
 }
 
 function getColor(elem, attr) {
 		var color;
 
 		do {
-				color = jQuery.curCSS(elem, attr);
+				color = $.curCSS(elem, attr);
 
 				// Keep going until we find an element that has color, or we hit the body
-				if ( color != '' && color != 'transparent' || jQuery.nodeName(elem, "body") )
+				if ( color != '' && color != 'transparent' || $.nodeName(elem, "body") )
 						break;
 
 				attr = "backgroundColor";
@@ -339,14 +339,14 @@
 */
 
 // t: current time, b: begInnIng value, c: change In value, d: duration
-jQuery.easing['jswing'] = jQuery.easing['swing'];
+$.easing['jswing'] = $.easing['swing'];
 
-jQuery.extend( jQuery.easing,
+$.extend( $.easing,
 {
 	def: 'easeOutQuad',
 	swing: function (x, t, b, c, d) {
-		//alert(jQuery.easing.default);
-		return jQuery.easing[jQuery.easing.def](x, t, b, c, d);
+		//alert($.easing.default);
+		return $.easing[$.easing.def](x, t, b, c, d);
 	},
 	easeInQuad: function (x, t, b, c, d) {
 		return c*(t/=d)*t + b;
@@ -455,7 +455,7 @@
 		return c/2*((t-=2)*t*(((s*=(1.525))+1)*t + s) + 2) + b;
 	},
 	easeInBounce: function (x, t, b, c, d) {
-		return c - jQuery.easing.easeOutBounce (x, d-t, 0, c, d) + b;
+		return c - $.easing.easeOutBounce (x, d-t, 0, c, d) + b;
 	},
 	easeOutBounce: function (x, t, b, c, d) {
 		if ((t/=d) < (1/2.75)) {
@@ -469,8 +469,8 @@
 		}
 	},
 	easeInOutBounce: function (x, t, b, c, d) {
-		if (t < d/2) return jQuery.easing.easeInBounce (x, t*2, 0, c, d) * .5 + b;
-		return jQuery.easing.easeOutBounce (x, t*2-d, 0, c, d) * .5 + c*.5 + b;
+		if (t < d/2) return $.easing.easeInBounce (x, t*2, 0, c, d) * .5 + b;
+		return $.easing.easeOutBounce (x, t*2-d, 0, c, d) * .5 + c*.5 + b;
 	}
 });
 
Index: ui/ui.accordion.js
===================================================================
--- ui/ui.accordion.js	(revision 946)
+++ ui/ui.accordion.js	(working copy)
@@ -195,7 +195,7 @@
 		
 		if ( !options.alwaysOpen && clickedActive ) {
 			animOptions = {
-				toShow: jQuery([]),
+				toShow: $([]),
 				toHide: toHide,
 				complete: complete,
 				down: down,
@@ -265,9 +265,9 @@
 		var toHide = options.active.next(),
 			data = {
 				options: options,
-				newHeader: jQuery([]),
+				newHeader: $([]),
 				oldHeader: options.active,
-				newContent: jQuery([]),
+				newContent: $([]),
 				oldContent: toHide
 			},
 			toShow = (options.active = $([]));
Index: ui/effects.highlight.js
===================================================================
--- ui/effects.highlight.js	(revision 946)
+++ ui/effects.highlight.js	(working copy)
@@ -36,7 +36,7 @@
 		el.animate(animation, { queue: false, duration: o.duration, easing: o.options.easing, complete: function() {
 			if(mode == "hide") el.hide();
 			$.effects.restore(el, props);
-		if (mode == "show" && jQuery.browser.msie) this.style.removeAttribute('filter');
+		if (mode == "show" && $.browser.msie) this.style.removeAttribute('filter');
 			if(o.callback) o.callback.apply(this, arguments);
 			el.dequeue();
 		}});